/*
 *  reaction_set_map.cpp
 *  gpu_hierleap
 *
 *  Created by David Orendorff on 12/22/11.
 *  Copyright 2011 UC Irvine. All rights reserved.
 *
 */

#include "reaction_set_map.h"

#include <vector>
#include "delta_propensity_bounds.h"
#include "propensity_bounds.h"
#include "reaction_set.h"

using namespace std;

template <class Value>
Value & ReactionSetMap<Value>::operator[] (ReactionSet* r) {
	int idx = r->getUniqueId();
	assert(idx >= 0);
	if (idx >= _mapping.size()) {
		_enlarge(max(idx, r->getRoot()->numRxnSets()));
	}
	_count[idx] = 1;
	return _mapping[idx];
}

//template <class Value>
//Value ReactionSetMap<Value>::get(ReactionSet *r){
//	return _mapping[r->getUniqueId()];
//}

template <class Value>
void ReactionSetMap<Value>::_set(ReactionSet *r, Value v){
	_mapping[r->getUniqueId()] = v;
}

// Because this is a template class, we need to pre-declare which types will use this class.
template class ReactionSetMap<DeltaEquation*>;
template class ReactionSetMap<PropensityBounds*>;
template class ReactionSetMap<DeltaPropensityBounds*>;
template class ReactionSetMap<int>;