%% plot run times
% (cells, clock time)

gpu=[2 .09
7 .1
15 .12
30 .16
35  .175
38 .18];

cpu=[2 .005
7 .014
15 .05
30 .27
35 .38
38 .41];


plot(gpu(:,1), gpu(:,2),'-sk', 'LineWidth', 2);
hold on
plot(cpu(:,1), cpu(:,2),'-dk', 'LineWidth', 2)

legend('GPU OpenCl','CPU OpenCl')
ylim([0 .45])
xlabel('Problem Size')
ylabel({'t'})
hold off

%% Plot running times
plot(HIERGPU(:,1), HIERGPU(:,2),'k', 'LineWidth', 2);
hold on
plot(HIERCPU(:,1), HIERCPU(:,2),'b', 'LineWidth', 2)
hold off
semilogy(SSACPU(:,1), SSAGPU(:,2),'g', 'LineWidth', 2)
hold on
plot(SSAGPU(:,1), SSACPU(:,2),'r', 'LineWidth', 2)
hold off

legend('GPU Hierleap','CPU Hierleap', 'GPU SSA', 'CPU SSA', 'Location', 'NorthWest')
ylabel({'t'})
xlabel('Problem Size (cells)')
title('dsmts-001-01 (Optimal L 2-5)')
%ylim([0 max(HIERCPU(:,2))])

%% compares simulated vs. theoretical results for stochastic sim
% David Orendorff. 2/25/11.
%

%cd /Users/dweo/research/gpusvm/matlab_scripts
cd ../tests
%ret = system('rm test_results/*.txt'); 
% assert(ret == 0);

% slow ones: 1-5, 2-4, 
  %models = {'dsmts?001?01', 'dsmts?001?03', 'dsmts?001?04', 'dsmts?001?05', ...
	     %            'dsmts?002?01', 'dsmts?002?02', 'dsmts?002?04','dsmts?003?01', ...
	     %            'dsmts?003?02'} ;

% annoying hack, can't have array of variable length strings
% boolean array, if we run model or not
running_model = [[1 0 1 1 1]; [1 1 0 1 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[1 0 1 1 1]; [1 1 0 1 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 0 0 0]; [1 1 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 0 0 0]; [1 1 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 0 0 0]; [1 0 0 0 0]; [0 0 0 0 0];[0 0 0 0 0]];
%running_model = [[1 0 0 0 1]; [1 1 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]]
%running_model = [[1 0 1 1 0]; [1 1 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]]
%running_model = [[0 0 0 0 0]; [0 0 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 0 0 0]; [0 0 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 0 0 0]; [1 1 0 1 0]; [1 1 0 0 0];[0 0 0 0 0]];
normed_vals = [];

warning off all
totMeanErrs = 0;

%for i = 1:50
for model = 1:4
    for variation = 1:5
        if running_model(model,variation)==0
            continue
        end
        m_name = sprintf('dsmts-00%d-0%d', model, variation)
        
        ret = system('rm test_results/*.txt');
        assert(ret == 0)
        %cmdSim = sprintf('../build/Release/gpu_hierleap -f cases/%s.xml -r 20 -t 50 -p 1 -o test_results -l 3 -c GPU -a HIER -x 100', m_name);
        cmdSim = sprintf('../build/Release/gpu_hierleap -f cases/%s.xml -r 50 -t 50 -p 1 -o test_results -l 5 -c None -a HIER -x 50 --seed 229', m_name);
        %[status result] = system(cmdSim);
        status = system(cmdSim);
        
        if status ~= 0
            'hier leap failed to execute'
            cmdSim
            continue
            %return
        end
        
        % w = load('test_results/time.txtc');
        mean_data = load(sprintf('cases/%s-mean.csv', m_name));
        std_data = load(sprintf('cases/%s-sd.csv', m_name));
        
        if model ~= 3
            if model==4
                true_mean = mean_data;
                true_std = std_data;
            else
                true_mean = mean_data(:,2)';
                true_std = std_data(:,2)';
            end
            cmdFixOutput = 'python removeLastLineAndCondense.py test_results/X*.txt';
            [status result] = system(cmdFixOutput);

            assert(status == 0);
            x = load('test_results/all_collapsed.txt');
            %x = load('/Users/dweo/research/gpusvm/build/Release/X.txt');
            %x = load('/Users/dweo/research/gpu_hierleap/build/Release/out/X_0_0_0.txt.trunc');

            [n,time_points] = size(x);
            x_normed = sqrt(n) * (mean(x) - true_mean)./[1 true_std(2:51)];
            num_off_mean = sum(abs(x_normed) > 3);
            'not plotting because of matlab bug'
            %plot(x_normed); % TODO: we can remove this plot

%             % weighted scenario 
%             xw_mean = sum(x.*w)./sum(w);
%             xw_normed = (sum(w).^0.5).* (xw_mean - true_mean)./true_std;
%             num_off_mean_w = sum(abs(xw_normed) > 3);


            % test standard deviation
            sx = std(x);
            x_sd_normed = sqrt(n/2) * (std(x)./true_std - 1);
            num_off_sd = sum(abs(x_sd_normed) > 5);
            
            normed_vals = [normed_vals x_normed];
            errors = num_off_mean + num_off_sd;

        else
            P_fix_output = 'python removeLastLineAndCondense.py test_results/P_*.txt';
            P2_fix_output = 'python removeLastLineAndCondense.py test_results/P2_*.txt';
            ret = system(P_fix_output)
            assert(ret == 0);
            p = load('test_results/all_collapsed.txt');
            
            P2_fix_output = 'python removeLastLineAndCondense.py test_results/P2_*.txt';
            ret = system(P2_fix_output)
            assert(ret == 0);
            p2 = load('test_results/all_collapsed.txt');

            n = length(p);

            ptrue_mean = mean_data(:,2)';
            p2true_mean = mean_data(:,3)';
            ptrue_std = std_data(:,2)';
            p2true_std = std_data(:,3)';
            
            p_normed = sqrt(n) * (mean(p) - ptrue_mean)./ptrue_std;
            p2_normed = sqrt(n) * (mean(p2) - p2true_mean)./p2true_std;
            
            num_off_mean = sum(abs([p_normed ]) > 3);
            

%             pw_mean = sum(w.*p)./sum(w);
%             p2w_mean = sum(w.*p2)./sum(w);
%             
%             pw_normed =  sqrt(n)*(pw_mean - ptrue_mean)./ptrue_std;
%             p2w_normed = ((sum(w)).^.5).*(p2w_mean - p2true_mean)./p2true_std;
%             errors_w =  sum(abs([pw_normed]) > 3);


            % std analysis
            p_sd_normed = sqrt(n/2) * (std(p)./ptrue_std - 1);
            p2_sd_normed = sqrt(n/2) * (std(p2)./p2true_std - 1);
            
            %plot(p_normed);

            num_off_sd = sum(abs([p_sd_normed p2_sd_normed]) > 5);

            errors = num_off_mean + num_off_sd;
            normed_vals = [normed_vals p_normed];
                
        end
        
        if errors > 1
            [m_name ' test failed!']
            num_off_sd
            num_off_mean
            totMeanErrs = totMeanErrs + 1;
        else
            ['test passed for ', m_name]
        end
    end
    
end
'total errors...'
totMeanErrs
