/*
 * reaction_leaper.h
 *
 *  Created on: Sep 3, 2009
 *      Author: dweo
 */

#ifndef REACTION_LEAPER_H_
#define REACTION_LEAPER_H_

#include <vector>
#include "../reactions/reactions.h"
#include "../reactions/reaction.h"
#include "../reactions/reaction_permutation.h"
#include "../state/state.h"

//class State;
//class Reactions;
//class Reaction;
//template <Reaction*> class ReactionPermutation;

using namespace hierleap;

// Abstract ReactionLeaper
class ReactionLeaper{
public:
	ReactionLeaper() : _MAX_ARRLEN(2000){
		_multiReturn.reserve(_MAX_ARRLEN);
	}
	
	// returns an ordered list of reactions of length leap :
	//	- sampled from SSA equivalent process
	//	- this is guaranteed to be recursive with bottom call to ERLeap
	virtual ReactionPermutation<Reaction*> * ReactionLeap(State *state, Reactions *root) = 0;

	vector<unsigned int> & multinomialSelect(vector<double> & unnormalizedProbs, int events);

	virtual ~ReactionLeaper(){}
	
private:
	vector<unsigned int> _multiReturn; // TODO probably not be thread safe
	const int _MAX_ARRLEN;
};

#endif /* REACTION_LEAPER_H_ */
