
#include "reaction_tally.h"

#include <stdio.h>
#include <boost/foreach.hpp>

#include "../reactions/reaction_set.h"
#include "../reactions/reactions.h"

using namespace hierleap;

void ReactionTally::_printHelper(ReactionSet *r, int totRxns){
	int i = r->getUniqueId();
	printf("%s(%d):\t%d/%d=%f\n", r->myName(), i, _rxnEvents[i], 
			totRxns, double(_rxnEvents[i]) / totRxns);
	if (r->isReaction()) return;
	
	BOOST_FOREACH(ReactionSet *c, r->getDependents()){
		_printHelper(c, totRxns);
	}
}



void ReactionTally::_tallyEvent(ReactionSet *r){
	int idx = r->getUniqueId();
	if (idx >= (int)_rxnEvents.size()){
		_rxnEvents.resize(idx+1);
	}
	_rxnEvents[idx]++;
	
	// go up the tree
	if (r->getParent()){
		_tallyEvent((ReactionSet*)r->getParent());
	}
}

int ReactionTally::_totReactionEvents(ReactionSet *r){
	if (r->isReaction()) return _rxnEvents[r->getUniqueId()];
	
	int acc=0;
	vector<ReactionSet*> & deps = r->asReactions()->getDependents();

	BOOST_FOREACH( ReactionSet *c,  deps){
		acc += _totReactionEvents(c);
	}
	return acc;
}