/*
 * Reaction_tally.h
 *
 *  Created on: Sep 15, 2009
 *      Author: dweo
 */

#include <vector.h>
#include <numeric>

#include "../reactions/reaction.h"
#include "../reactions/reaction_permutation.h"

using namespace hierleap;

#ifndef REACTION_TALLY_H_
#define REACTION_TALLY_H_

// Tally when reactions occur s.t. we can calculate probability of firing, etc
class ReactionTally {
public:
	ReactionTally(Reactions *root){
		_root = root;
		_rxnEvents.reserve(1000);
	}

	void tally(ReactionPermutation<Reaction*> *reactions){
		reactions->lockOrder();
		while(reactions->hasNext()){
			Reaction *r = reactions->next();
			_tallyEvent(r);
		}
	}

	// TODO make work for debugin'
	// TODO include parent rxn probs
	void printResults(){ 
		int totRxns = _totReactionEvents((ReactionSet*)_root); 
		//_printOnlyOneReactionEventProb(9, totRxns);
		//return;
		
		
		_printHelper((ReactionSet*)_root, totRxns);
		
		
//		for (unsigned int i=0; i < _rxnEvents.size(); i++){
//			if (_rxnEvents[i]==0) continue;
//			printf("%d:\t%d/%d=%f\n", i, _rxnEvents[i], totRxns, double(_rxnEvents[i]) / totRxns);
//		}
//		
//		
//		// warn about 
//		printf("skipped (no reaction events):\n");
//		for (unsigned int i=0; i < _rxnEvents.size(); i++){
//			if (_rxnEvents[i]!=0) continue;
//			printf(",%d ", i);
//		}
//		printf("\n");
	}

private:
	
	void _printOnlyOneReactionEventProb(int rxnIdx, int totEvents){
		printf("%f\n", float(_rxnEvents[rxnIdx]) /  totEvents);
	}
	
	int _totReactionEvents(ReactionSet *r);
	
	void _printHelper(ReactionSet *r, int totRxns);
	
	void _tallyEvent(ReactionSet *r);
	
	vector<int> _rxnEvents;
	Reactions *_root;
};

#endif /* REACTION_TALLY_H_ */
