#ifndef REACTION_TAU_LEAPER_H_
#define REACTION_TAU_LEAPER_H_

#include <assert.h>

class State;
template <class T> class ReactionPermutation;

namespace hierleap{
	class Reaction;
}
using namespace hierleap;
//class Reaction;

class ReactionTauLeaper{
public:
	
	// Updates state. Returns time delta. Returns which total propensity of system after reactions have been fired.
	// If dt==0 then no reactions were able to progress.
	virtual double ReactionTauLeap(int leap, State *s, double &dt) = 0;
	
	virtual void changeRuntimeParameters(State *s, int leap) = 0;
	
	virtual char* name() = 0;
	
	virtual double getPreviousAcceptanceProbability() {
		return -1;
	}
	
};

#endif /*REACTION_TAU_LEAPER_H_*/
