%% compares simulated vs. theoretical results for stochastic sim
% David Orendorff. 7/19/07.
%

% slow ones: 1-5, 2-4, 
%models = {'dsmts?001?01', 'dsmts?001?03', 'dsmts?001?04', 'dsmts?001?05', ...
%            'dsmts?002?01', 'dsmts?002?02', 'dsmts?002?04','dsmts?003?01', ...
%            'dsmts?003?02'} ;

% annoying hack, can't have array of variable length strings
% boolean array, if we run model or not
running_model = [[1 0 1 1 1]; [1 1 0 1 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 0 0 0]; [1 1 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 0 0 0]; [1 1 0 1 0]; [0 0 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 1 0 0]; [0 0 0 0 0]; [0 1 0 0 0];[0 0 0 0 0]];
%running_model = [[1 0 1 1 0]; [1 1 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]]
%running_model = [[1 0 1 1 0]; [1 1 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]]
%running_model = [[0 0 1 0 0]; [0 0 0 0 0]; [1 1 0 0 0];[0 0 0 0 0]];
%running_model = [[1 0 0 0 0]; [0 0 0 0 0]; [0 0 0 0 0];[0 0 0 0 0]];
%running_model = [[0 0 0 0 0]; [1 1 0 1 0]; [1 1 0 0 0];[0 0 0 0 0]];
normed_vals = [];

warning off all

%for i = 1:50
for model = 1:4
    for variation = 1:5
        if running_model(model,variation)==0
            continue
        end
        m_name = sprintf('dsmts-00%d-0%d', model, variation);
        
        cmd = sprintf('../Release/er_leap cases/%s.xml 20000 50 1 test_results 5', m_name)
        [status result] = system(cmd);

        if status ~= 0
            'er leap failed to execute'
            cmd
            return
        end

        
        w = load('test_results/time.txtc');
        mean_data = load(sprintf('cases/%s-mean.csv', m_name));
        std_data = load(sprintf('cases/%s-sd.csv', m_name));
        
        if model ~= 3
            if model==4
                true_mean = mean_data;
                true_std = std_data;
            else
                true_mean = mean_data(:,2)';
                true_std = std_data(:,2)';
            end
            x = load('test_results/X.txtc');

            [n,time_points] = size(x);
            x_normed = sqrt(n) * (mean(x) - true_mean)./[1 true_std(2:51)];
            num_off_mean = sum(abs(x_normed) > 3);

            % weighted scenario 
            xw_mean = sum(x.*w)./sum(w);
            xw_normed = (sum(w).^0.5).* (xw_mean - true_mean)./true_std;
            num_off_mean_w = sum(abs(xw_normed) > 3);


            % test standard deviation
            sx = std(x);
            x_sd_normed = sqrt(n/2) * (std(x)./true_std - 1);
            num_off_sd = sum(abs(x_sd_normed) > 5);
            
            normed_vals = [normed_vals x_normed];
            errors = num_off_mean + num_off_sd;

        else
            p = load('test_results/P.txtc');
            p2 = load('test_results/P2.txtc');

            n = length(p);


            ptrue_mean = mean_data(:,2)';
            p2true_mean = mean_data(:,3)';
            ptrue_std = std_data(:,2)';
            p2true_std = std_data(:,3)';
            
            p_normed = sqrt(n) * (mean(p) - ptrue_mean)./ptrue_std;
            p2_normed = sqrt(n) * (mean(p2) - p2true_mean)./p2true_std;
            
            num_off_mean = sum(abs([p_normed ]) > 3);
            

            pw_mean = sum(w.*p)./sum(w);
            p2w_mean = sum(w.*p2)./sum(w);
            
            pw_normed =  sqrt(n)*(pw_mean - ptrue_mean)./ptrue_std;
            p2w_normed = ((sum(w)).^.5).*(p2w_mean - p2true_mean)./p2true_std;
            errors_w =  sum(abs([pw_normed]) > 3);


            % std analysis
            p_sd_normed = sqrt(n/2) * (std(p)./ptrue_std - 1);
            p2_sd_normed = sqrt(n/2) * (std(p2)./p2true_std - 1);

            num_off_sd = sum(abs([p_sd_normed p2_sd_normed]) > 5);

            errors = num_off_mean + num_off_sd;
            normed_vals = [normed_vals p_normed];
                
        end
        
        if errors > 1
            [m_name ' test failed!']
            num_off_sd
            num_off_mean
        else
            ['test passed for ', m_name]
        end
    end
end
%end

%% 
model =3
variation = 2
m_name = sprintf('dsmts-00%d-0%d', model, variation);

p = load('/Users/dweo/research/temp/build/Release/trace.txt');
n=length(p)
mean_data = load(sprintf('cases/%s-mean.csv', m_name));
ptrue_mean = mean_data(:,2)';

    std_data = load(sprintf('cases/%s-sd.csv', m_name));
    ptrue_std = std_data(:,2)';
    p2true_std = std_data(:,3)';
    
p_normed = sqrt(n) * (mean(p) - ptrue_mean)./ptrue_std;
num_off_mean = sum(abs([p_normed]) > 3)

%% generate graphs for extended abstract
% 4 plots, top two show actual values, 

model = 1; variation = 3;
m_name = sprintf('dsmts-00%d-0%d', model, variation);

cmd = sprintf('../Release/er_leap cases/%s.xml 30000 50 1 test_results 4', m_name);
[status result] = system(cmd);
if status ~= 0
    'er leap failed to execute'
    return
end

mean_data = load(sprintf('cases/%s-mean.csv', m_name));
true_mean = mean_data(:,2)';
std_data = load(sprintf('cases/%s-sd.csv', m_name));
true_std = std_data(:,2)';

% leap data
xL = load('test_results/X.txtc');
xL_mean = mean(xL);

% gillespie data
cmd = sprintf('../Release/er_leap cases/%s.xml 30000 50 1 test_results 1', m_name);
[status result] = system(cmd);
if status ~= 0
    'gill failed to execute'
    return
end

xG = load('test_results/X.txt');
xG_mean = mean(xG);

xG_sd = std(xG);
xL_sd = std(xL);

% standardize values
nL = length(xL);
nG = length(xG);
xL_normed = sqrt(nL) * (xL_mean - true_mean)./true_std;
xG_normed = sqrt(nG) * (xG_mean - true_mean)./true_std;

xL_sd_normed = sqrt(nL/2) * (xL_sd./true_std - 1);
xG_sd_normed = sqrt(nG/2) * (xG_sd./true_std - 1);

%% plot means of ER-leap, SSA and Z/Y values
f = figure;
subplot(2,2,1);

plot(0:50, true_mean, 'k');
grid off
box off
hold on
er_marker = 'sk';
ssa_marker = '^k';

% plot means
plot(0:2:50, xL_mean(1:2:51), er_marker);
plot(1:2:50, xG_mean(2:2:51), ssa_marker);
%legend('Analytical', 'ER-leap', 'SSA');
xlim([0 50])
hold off

title([{'Sample', 'Mean'}],'FontSize',12,'FontWeight','Bold');
%legend('Analytical Solution', 'ER-leap (L=5)', 'SSA');
xlabel('time');
%ylabel('mean (molecules)')

% plot standard deviations
subplot(2,2,2);
plot(0:50, true_std, 'k');
grid off
box off
hold on
plot(0:2:50, xL_sd(1:2:51), er_marker);
plot(1:2:50, xG_sd(2:2:51), ssa_marker);
xlim([0 50])
hold off

title({'Sample','Standard Deviation'},'FontSize',12,'FontWeight','Bold');
%legend('Analytical Solution', 'ER-leap (L=5)', 'SSA');
xlabel('time');
%ylabel('STD (molecules)')

% plot mean Z
subplot(2,2,3);
plot(0:50, xL_normed, er_marker);
hold on
plot(0:50, xG_normed, ssa_marker);
grid off
box off
ylim([-3,3]);
xlim([0 50])
hold off

title({'','Z_t (mean)'},'FontSize',12,'FontWeight','Bold');
xlabel({'time',''});
%ylabel('Z', 'Rotation',0);
%legend('ER-leap', 'SSA');

% plot SD Y-score
subplot(2,2,4);
plot(0:50, xL_sd_normed, er_marker);
hold on
box off
plot(0:50, xG_sd_normed, ssa_marker);
grid off
ylim([-5,5]);
xlim([0 50])
hold off

title({'','Y_t (std)'},'FontSize',12,'FontWeight','Bold');
xlabel('time');
%ylabel('Y','Rotation',0);


%% %%%%%%%%%%%%%%%% Plot Z value comparison of SSA, R/ER/Tau-leap for paper %%%%%%%%%

% tries to see if an vars are in the workspace yet
if length(who)==0
    load erleap.txt
    load ssa.txt
    load rleap.txt
    load tauleap.txt
end

legend_handles=[];%method;
f=figure;

for method=1:4
%for method=[1]
    method
b_rate = .11; % lambda
d_rate = .1; % mu
mlcs = 100000;

if(b_rate <= d_rate)
    error('birth smaller than death rate!');
end

% saclient output file
if method==1
     data = erleap;
    c = 'sk';
elseif method==2
    data = ssa;
    c = '^k';
elseif method==3
    data = tauleap;
    c = 'xk';
else 
    data = rleap;
    c = 'ok';
end

% does NOT do one time-step at a time...

incr_n=1000 %increment value
mlcs = 100000
stds_normed = [];
xs_normed = [];
hidx=1;
mean_failed=0;
std_failed=0;

[sorted,sort_idx] = sort(data(:,1));
data(:,1) = sorted;
data(:,2) = data(sort_idx,2);

for i=1:(length(data)/incr_n)

%idx = (incr_n*(i-1)+1):(incr_n*i);
idx = (incr_n*(i-1)+1):1:(incr_n*i);
times = data(idx,1);

x = data(idx,2);

n = length(x);

r_diff = b_rate - d_rate;
bd_mean = mlcs * exp(r_diff * times);

bd_var = mlcs*exp(2*(b_rate - d_rate)*times).*(1 - exp((d_rate - b_rate)*times))*(d_rate + b_rate)/(b_rate - d_rate);
bd_std = sqrt(bd_var);

true_std = max(bd_std);
%x_normed = sqrt(n) * mean(x - bd_mean)./true_std; % not sure what to divide by...
%%x_normed = sqrt(n) * mean((x - bd_mean)./bd_std); % not sure what to divide by...
%x_normed = sqrt(n) * mean((x - mean(bd_mean))./bd_std); % not sure what to divide by...
x_normed = sqrt(n) * mean((x - mean(bd_mean))/true_std);

if abs(x_normed) > 3
    'test failed';
    x_normed;
    mean_failed = mean_failed+1;
else
    'mean test passed!';
end

%x_sd_normed = sqrt(n/2) * (std(x)./true_std - 1);
x_sd_normed = sqrt(n/2) * mean(std(x-bd_mean)./bd_std - 1);
if abs(x_sd_normed) > 3
    'test failed';
    x_sd_normed;
    std_failed = std_failed+1;
else
    'std test passed!';
end
xs_normed(hidx) = x_normed;
stds_normed(hidx) = x_sd_normed;
hidx = hidx+1;

end


mean_failed
std_failed


% PLOT STUFF

% plot histogram spline interpolations
[N,BIN]=hist(xs_normed,9); % BIN is x-values, N is y

dx_half = abs(BIN(1)-BIN(2))/2;
BIN = [min(BIN)-dx_half, BIN, max(BIN)+dx_half];
N = [0 N 0];

Nlen=length(N);
area = sum(diff(BIN).*N(1:Nlen-1));
area = area + sum(diff(BIN).*N(2:Nlen));
area = area /2;
N = N / area;

PP = spline(BIN,N);
X = min(BIN):.01:max(BIN);
plot(X, ppval(PP, X), 'k-', 'LineWidth', 1);

hold on
%plot(BIN,N/area,c)
legend_handles(method) = plot(BIN,N,c,'LineWidth', 2);

end

% set y-lim to 0 and draw verticle line.
y_lim = ylim;
ylim([0,y_lim(2)]);
plot([0 0], ylim, 'k', 'LineWidth', 1);
legend(legend_handles, 'ER-leap', 'SSA', 'tau-leap','R-leap','Location','NorthWest')
xlabel('Z')
ylabel('Probability')
% grid on
box off
hold off

cd /Users/dweo/research/er_leap_paper/figures/revisions
exportfig(gcf, 'fig2_zscorecompare.eps','Width',3.375, 'Height',3.375,'FontSize',11,'FontMode','fixed','FontEncoding','adobe')


%% PLOT deterministic 'pigtail' Wang system..
cd /Users/dweo/research/er_leap_paper/data/det_pigtail_Wang

load ssaX.txt
load ssaY.txt

plot(ssaX, ssaY, 'k');
xlabel('X');
ylabel('Y');
xlim([39570, 81000]);
ylim([450000, 560000]);
box off
axis square
text(4.1e4,5.1e5,'t=0')
text(6.1e4,4.6e5,'t=0.2')
previewfig(gcf, 'Width',3.5, 'Height',3.5,'FontSize',11,'FontMode','fixed','FontEncoding','adobe')
%exportfig(gcf, 'fig3.eps','Width',3.5, 'Height',3.5,'FontSize',11,'FontMode','fixed','FontEncoding','adobe')

%% PLOT mean chaotic trajectory, for ER-leap paper!
cd /Users/dweo/research/er_leap_paper/data/chaotic_regime_Wang/ssa_prev

X=load('c_out_X.fix');
Y=load('c_out_Y.fix');
%%
plot(mean(X), mean(Y), 'k');
xlabel('X');
ylabel('Y');

%xlim([0 7e4])
%ylim([0 7e4])
%axis square
%previewfig(gcf, 'Width',3.5, 'Height',2.75,'FontSize',11,'FontMode','fixed','FontEncoding','adobe')

%% PLOT Histrogram of distribution, Density plot for ER-leap paper... %%

cd /Users/dweo/research/er_leap_paper/data/chaotic_regime_Wang

%cd /Users/dweo/research/er_leap_paper/data/pigtail_Wang

for method=[2,3,4,1]
%for method=[1]
    method


% which output files, assumes we are in a directory with method names as
% member directories.
if method==1
     cd erleap
     name='ER-leap';
     loc = [1,1];
elseif method==2
    cd ssa
    name='SSA';
    loc = [1,2];
elseif method==3
    cd tauleap;
    name='\tau-leap';
    loc = [2,1];
else 
    cd rleap;
    name='R-leap';
    loc = [2,2];
end

X=load('c_out_X.fix'); % may need to remove .fix, depending..
Y=load('c_out_Y.fix');
X = reshape(X,prod(size(X)), 1);
Y = reshape(Y,prod(size(Y)), 1);

cd ..

n=86;

[bins bin_pts] = hist3([X, Y], [n n]);
bins = (bins+1) / numel(X);
subplot(2,2,method);
contourf(bin_pts{1}, bin_pts{2}, log(bins'), -15:-6);


minmax = @(x) [min(x) max(x)];
xlim(minmax(bin_pts{1}));
ylim(minmax(bin_pts{2}));


% 
% xsize=numel(X);
% vX=reshape(X,[xsize,1]);
% vY=reshape(Y,[xsize,1]);
% 
% minX =  min(min(X));
% maxX = max(max(X));
% minY = min(min(Y));
% maxY = max(max(Y));
% 
% vX = round((n-1)*(vX - min(vX))/(max(vX)-min(vX)))+1;
% vY = round((n-1)*(vY - min(vY))/(max(vY)-min(vY)))+1;
% m = full(sparse(vX,vY,ones(length(vX),1)));
% 
% subplot(2,2,method);
% contourf(log(m'+1)); % surf
% 
% 
% xlim([1 n]);
% ylim([1 n]);
% 
% fmt = '%0.2G';
% set(gca,'XTick',[1, n/2, n]);
% set(gca,'YTick',[1, n/2, n]);
% xlabels = {num2str(minX,fmt), num2str(round((maxX-minX)/2),fmt), num2str(maxX,fmt)};
% ylabels = {num2str(minY,fmt), num2str(round((maxY-minY)/2),fmt), num2str(maxY,fmt)};
% set(gca,'XTickLabel',xlabels);
% set(gca,'YTickLabel',ylabels);

xlabel('X','FontSize',11,'FontWeight','Bold');
ylabel('Y','FontSize',11,'FontWeight','Bold');

colormap gray
colorbar;
title(name,'FontSize',12,'FontWeight','Bold');
%axis off
axis square

end
%exportfig(gcf, 'fig7.eps','Width',3.5, 'Height',2.25,'FontSize',11,'FontMode','fixed','FontEncoding','adobe')

%% PLOT point plots for PAPER... %%

cd /Users/dweo/research/er_leap_paper/data/pigtail_Wang_zoomout

for method=[2,3,4,1]
%for method=[2]
    method


% which output files, assumes we are in a directory with method names as
% member directories.
if method==1
     cd erleap
     name='ER-leap';
     loc = [1,1];
elseif method==2
    cd ssa
    name='SSA';
    loc = [1,2];
elseif method==3
    cd tauleap;
    name='\tau-leap';
    loc = [2,1];
else 
    cd rleap;
    name='R-leap';
    loc = [2,2];
end

X=load('c_out_X.fix'); % may need to remove .fix, depending..
Y=load('c_out_Y.fix');

X = X(:,1:77); % XXX: this may be temporary
Y = Y(:,1:77);

cd ..

subplot(2,2,method);
x=[
    0.03       0.02474    .06
    0.0000    0.1840    0.2982
    0.1818    0.1794    0.6776
    0.1118    0.6190    0.6176
    0.4039    0.8575    0.0207
    0.6324    0.9038    0.8599
    0.9944    0.8583    0.5511
    ];

% do some interpolations on mean for smoothing
smoothfactor = 100;
xnew = interp(mean(X), smoothfactor); ynew = interp(mean(Y), smoothfactor);
plot(xnew, ynew,'k')
hold on
set(gca,'ColorOrder',x)
plot(X,Y,'.')
hold off

xlim([0 2.2e5])
ylim([2e5 8.5e5])

xlabel('X','FontSize',11,'FontWeight','Bold');
ylabel('Y','FontSize',11,'FontWeight','Bold');

title(name,'FontSize',12,'FontWeight','Bold');
%axis off
%axis square

end
%exportfig(gcf, 'fig7.eps','Width',3.5, 'Height',2.25,'FontSize',11,'FontMode','fixed','FontEncoding','adobe')


%% For ER-leap PAPER, plot speedup of ER-leap with L
%load combx;
%load combrun;
cd /Users/dweo/research/er_leap_paper/data/explore_L;
load leap_runtimes.txt 
runspersample = 29;

leap = leap_runtimes(1,:);
runtimes = leap_runtimes(2:end, :) / runspersample;

surf(leap, 1:5, runtimes);
xlabel('leap(L)');
zlabel('CPU time (s)');
colormap gray
grid off
xlim([-20 700])
view([0 0])
%xlim([-10,1000]);
cd /Users/dweo/research/er_leap_paper/figures/revisions
exportfig(gcf, 'fig9_leapScales.eps','Width',3.375, 'Height',2.4,'FontSize',11,'FontMode','fixed','FontEncoding','adobe')


%% for ER-leap paper, plot RXN scaling...
% note: get data erleap_vs_ssa.rtf
erleap=[erleap1,erleap8, erleap27, erleap64];
ssa=[ssa1,ssa8,ssa27,ssa64];
speedup = ssa./erleap;
rxns=[3 152  594 1504];

f=figure;
errorbar(rxns,mean(speedup), std(speedup),'.');
title('ER-leap Speedup')
xlabel('Reaction channels')
ylabel('SSA/ER-leap (CPU time)')
xlim([-30 1600])
%ylim([0 5])
box off
exportfig(f, 'fig11.eps','Width',3.375, 'Height',2.25,'FontSize',11,'FontMode','fixed','FontEncoding','adobe')

%% %%%%% for paper  use colormap, plot log CPU time 
%subplot(2,1,1)

%load S0.txt; load S1.txt; load S2.txt; load S3.txt;
%plot(S0); hold on ;plot(S1); plot(S2); plot(S3); hold off;
xlabel('simulation time');

%subplot(2,1,2);
x=[.5:.5:6];
load leap_runtimes.txt
leaps = 1:1:48;
nruns = 500;

contourf(x, leaps, log(leap_runtimes'/nruns), 19)
colorbar
colormap bone
ylabel('leap (L)');
xlabel('simulated time (t)')
title('Log CPU time cost / unit sim time','FontSize',12,'FontWeight','Bold');

% overplot the chosen leap
hold on
load leap_hist.txt
load optimal_leap.txt
load best_leap.txt
best_leap = optimal_leap;

% comes from leap_hist.txt. times 0.5:.5:6.  
%dynaleap = [28 26 24 22 20 18 16 14 13 11 10 9];

p = polyfit(leap_hist(:,1), leap_hist(:,2), 7);
p1=plot(x, best_leap, 's-b', 'LineWidth',3);
p2=plot(x, polyval(p,x), 'd-y', 'LineWidth',3);
%plot(leap_hist(:,1),leap_hist(:,2),'r');
hold off

legend([p1 p2], 'optimal L', 'heuristic L')

%% use colormap, 3d plot runtimes
%subplot(2,1,1)


%subplot(2,1,2);
x=[1:5];
load ../out/leap_runtimes.txt
leaps = 1:4:396;
v = log([.1:.01:.40])

surf(x,leaps, leap_runtimes')
%colorbar
colormap autumn
ylabel('leap (L)');
xlabel('simulated time, t')
zlabel('CPU time cost / unit sim time');
title('CPU time cost / unit sim time   (Birth/Death, 5314410 initial mlcs)','FontSize',16,'FontWeight','Bold');

%% look at biases
subplot(2,1,1)
hist(normed_vals);
title('unormalized hist of z-score, 2550 datapoints, L=1, mean=-0.1188, dstms?001?01')
subplot(2,1,2)
for i=1:50
    m(i)=mean(normed_vals(i:51:2550));
end
plot(m)
title('where biases are coming from')
xlabel('time')
ylabel('bias')

%% generate true data for tests using birth/death process

mlcs = 100000;
b_rate = 0.11; % lambda
d_rate = 0.10; % mu

t = 0:50;

if(b_rate <= d_rate)
    error('birth smaller than death rate!');
end

r_diff = b_rate - d_rate;
bd_mean = mlcs * exp(r_diff * t);
%bd_var = exp(2*r_diff*x).*(1 - exp(-r_diff*x))*(b_rate + d_rate)/r_diff;

lam = b_rate; mu = d_rate;
bd_var = mlcs*exp(2*(lam - mu)*t).*(1 - exp((mu - lam)*t))*(mu + lam)/(lam - mu);

bd_std = sqrt(bd_var);
%save bd_mean.txt bd_mean -ASCII
%save bd_std.txt bd_std -ASCII
plot(bd_mean)

%% test against saclient results of birth/death process

for method=1:4
    method
b_rate = .11; % lambda
d_rate = .1; % mu
mlcs = 100000;

if(b_rate <= d_rate)
    error('birth smaller than death rate!');
end

% saclient output file
if method==1
    data = load('/Users/dweo/research/stoch_alg/tests/ssa_t5.680000');
    c = 'r--';
elseif method==2
    data = load('/Users/dweo/research/stoch_alg/tests/erleap_t5.680000');
    c = 'b--';
elseif method==3
    data = load('/Users/dweo/research/stoch_alg/tests/rleap_t5.770000');
    c = 'c--';
else 
    data = load('/Users/dweo/research/stoch_alg/tests/tauleap_t5.770000');
    c = 'g--';
end
%%  modified for analyze saclient data, generalize later...
incr_n=1000*50 %increment value
mlcs = 100000
stds_normed = [];
xs_normed = [];
hidx=1;
for i=1:(length(data)/incr_n)

for t=1:50    
    
%idx = (incr_n*(i-1)+1):(incr_n*i);
idx = (incr_n*(i-1)+t):50:(incr_n*i);
times = data(idx,1);
x = data(idx,2);

n = length(x);

r_diff = b_rate - d_rate;
bd_mean = mlcs * exp(r_diff * times);

bd_var = mlcs*exp(2*(b_rate - d_rate)*times).*(1 - exp((d_rate - b_rate)*times))*(d_rate + b_rate)/(b_rate - d_rate);
bd_std = sqrt(bd_var);

true_std = max(bd_std);
%x_normed = sqrt(n) * mean(x - bd_mean)./true_std; % not sure what to divide by...
x_normed = sqrt(n) * mean((x - bd_mean)./bd_std); % not sure what to divide by...
%x_normed = sqrt(n) * mean((x - mean(bd_mean))./bd_std); % not sure what to divide by...
%x_normed = sqrt(n) * mean((x - mean(bd_mean))./true_std);

if abs(x_normed) > 3
    'test failed'
    i
    mean(times)
    x_normed
else
    'mean test passed!';
end

%x_sd_normed = sqrt(n/2) * (std(x)./true_std - 1);
x_sd_normed = sqrt(n/2) * (std(x-bd_mean)./true_std - 1);
if abs(x_sd_normed) > 3
    'test failed';
    i;
    x_sd_normed;
else
    'std test passed!';
end
xs_normed(hidx) = x_normed;
stds_normed(hidx) = x_sd_normed;
hidx = hidx+1;

end
end
%% does NOT do one time-step at a time...

incr_n=1000 %increment value
b_rate = 0.11; % lambda
d_rate = 0.10; % mu
mlcs = 100000
stds_normed = [];
xs_normed = [];
hidx=1;
mean_failed=0;
std_failed=0;

%for t=1:50
%data=erleap(t:50:5800000,:); % XXX: remove this line

for i=1:(length(data)/incr_n)
i
%idx = (incr_n*(i-1)+1):(incr_n*i);
idx = (incr_n*(i-1)+1):1:(incr_n*i);
times = data(idx,1);
x = data(idx,2);

n = length(x);

r_diff = b_rate - d_rate;
bd_mean = mlcs * exp(r_diff * times);

bd_var = mlcs*exp(2*(b_rate - d_rate)*times).*(1 - exp((d_rate - b_rate)*times))*(d_rate + b_rate)/(b_rate - d_rate);
bd_std = sqrt(bd_var);

true_std = max(bd_std);
%x_normed = sqrt(n) * mean(x - bd_mean)./true_std; % not sure what to divide by...
x_normed = sqrt(n) * mean((x - bd_mean)./bd_std); % not sure what to divide by...
%x_normed = sqrt(n) * mean((x - mean(bd_mean))./bd_std); % not sure what to divide by...
%x_normed = sqrt(n) * mean((x - mean(bd_mean))./true_std);

if abs(x_normed) > 3
    'test failed';
    x_normed;
    mean_failed = mean_failed+1;
else
    'mean test passed!';
end

%x_sd_normed = sqrt(n/2) * (std(x)./true_std - 1);
x_sd_normed = sqrt(n/2) * mean(std(x-bd_mean)./bd_std - 1);
if abs(x_sd_normed) > 3
    'test failed';
    x_sd_normed;
    std_failed = std_failed+1;
else
    'std test passed!';
end
xs_normed(hidx) = x_normed;
stds_normed(hidx) = x_sd_normed;
hidx = hidx+1;

end

mean_failed
std_failed

%%
incr=length(xs_normed)/50
m=[];
for t=1:50
    t
    r = ((t-1)*incr+1):(t*incr);
    m(t)=mean(xs_normed(r+1))
end
%%

% plot histogram spline interpolations
[N,BIN]=hist(xs_normed,7); % BIN is x-values, N is y
dx_half = abs(BIN(1)-BIN(2))/2;
BIN = [min(BIN)-dx_half, BIN, max(BIN)+dx_half];
N = [0 N 0];

PP = spline(BIN,N);
X = min(BIN):.01:max(BIN);
plot(X, ppval(PP, X), c, 'LineWidth', 2);
hold on
end
legend('ssa', 'er-leap', '-rleap','tau-leap')

%% log-log analysis
coeffs=polyfit(log(x(:,1)),log(x(:,2)),1)
loglog(x(:,1),x(:,2),'k.');
title('Molecules vs. CPU time running simulation');
xlabel('mlcs');
ylabel('CPU time');
% legend('erleap', 'tauleap', 'rleap', 'ssa')

%% analyze chaotic behavior
load X.txt
load Y.txt

N=1
%plot(X(N:1000),Y(N:1000), '.')
plot(mean(X(:,1:140)),mean(Y(:,1:140)),'k')
hold on
plot(X(:,1:110),Y(:,1:110),'.')
hold off
plot([X; Y]')

%% analyze chaotic behavior
X=load('/Users/dweo/research/stoch_alg/tests/chaotic/c_out_X.fix');
Y=load('/Users/dweo/research/stoch_alg/tests/chaotic/c_out_Y.fix');

N=1
%plot(X(N:1000),Y(N:1000), '.')
nmax = length(X);
%plot(mean(X(:,1:nmax)),mean(Y(:,1:nmax)),'k')
%hold on
%plot(X(:,1:nmax),Y(:,1:nmax))
plot([X; Y]')
hold off
%plot(mean(X),mean(Y))

%% flatten X, Y. make 2d hist of data. plot
n=86;

xsize=numel(X);
vX=reshape(X,[xsize,1]);
vY=reshape(Y,[xsize,1]);

vX = round((n-1)*(vX - min(vX))/(max(vX)-min(vX)))+1;
vY = round((n-1)*(vY - min(vY))/(max(vY)-min(vY)))+1;
m = full(sparse(vX,vY,ones(length(vX),1)));

%subplot(1,2,1);
contourf(log(m'+1)); % surf
colormap copper
axis off
axis square
%% make hist of 3d data
%Y=load('c_out_Y.fix');
%X=load('c_out_X.fix');
n=80
xsize=numel(X);
vX=reshape(X,[xsize,1]);
vY=reshape(Y,[xsize,1]);
vZ=reshape(Y,[xsize,1]);

vX = round((n-1)*(vX - min(vX))/(max(vX)-min(vX)))+1;
vY = round((n-1)*(vY - min(vY))/(max(vY)-min(vY)))+1;
vZ = round((n-1)*(vZ - min(vZ))/(max(vZ)-min(vZ)))+1;
%m = full(sparse(vX,vY,vZ,ones(length(vX),1)));
m=zeros(n,n,n);
for i=1:xsize
    m(vX(i),vY(i),vZ(i)) = m(vX(i),vY(i),vZ(i))+1;
end
'ended making m'
%subplot(1,2,1);
contour3(log(m+1)); % surf
%colormap copper
axis off
axis square


%%
xsize=numel(X2);
vX=reshape(X2,[xsize,1]);
vY=reshape(Y2,[xsize,1]);

vX = round((n-1)*(vX - min(vX))/(max(vX)-min(vX)))+1;
vY = round((n-1)*(vY - min(vY))/(max(vY)-min(vY)))+1;
m = full(sparse(vX,vY,ones(length(vX),1)));
subplot(1,2,2);
surf(m);

colormap bone


%%
n=length(X)
p=10
plot(X(:,1:p:n),Y(:,1:p:n),'.')

%% plot runtime scalings for 4 algs
use_mono = 1

if use_mono==1
    cd /Users/dweo/research/StochAlg/tests/speedup_mono
    fh = subplot(1,2,1); % for mono
    times = [33, 49, 73, 109, 163, 244, 366, 549, 823, 1234, 1851, 2776, 4164, 6246, 9369, ...
    14053, 21079, 31618, 47427, 71140, 106710, 160065, 240097, 360145, 540217, 810325, 1215487, 1823230, ...
    2734845, 4102267, 6153400, 9230100];
else
    cd /Users/dweo/research/StochAlg/tests/speedup_dim
    fh = subplot(1,2,2);
    times = [10, 15, 22, 33, 49, 73, 109, 163, 244, 366, 549, 823, 1234, 1851, 2776, 4164, 6246, 9369, ...
    14053, 21079, 31618, 47427, 71140, 106710, 160065, 240097, 360145, 540217, 810325, 1215487, 1823230, ...
    2734845, 4102267, 6153400, 9230100];
end

load ssa.txt
load erleap.txt
load rleap.txt
load tauleap.txt
xticks = [100,1000,10000,100000,1000000,10000000];
yticks = [0.00001 0.0001  0.001  0.0100 0.1 1.0000 10 ];

%runs=9;
runspersample = 10;

mlcs = [];
%ssa =[]; (runs*samples) x 2 
%erleap = [];
%rleap = [];
%tauleap = [];
maxy=-99999;
miny=1e90;
%fh = figure;

for showbar=[0 1] % if we are showing the errorbar this go around
for i=1:4
    if i==1
        x = ssa;
        c = '-ko';
    elseif i==2
        x = erleap;
        c = '-kp' 
    elseif i==3 
        x = rleap;
        c = '-k^' ;
    else
        x = tauleap;
        c = '-ks' ;
    end
    x = x / runspersample;
    
    % reshape, truncate first few data points
    runs = length(x)/length(times)
    x2 = reshape(x(:,2), length(times), runs)';
    %ntrunc = 13;
    ntrunc = 1
    t = times(ntrunc:length(times));
    x2 = x2(:,ntrunc:length(times));
    y = median(x2,1); %XXX: was mean, not median
    ystd = std(x2,1);
    
    miny = min([miny min(y)]);
    maxy = max([maxy max(y)]);
    
    % plot stuff
    n = length(t);
    xvals = [t(1) t(i+1:4:n-1) t(n)];
    y = [y(1) y(i+1:4:n-1) y(n)];
    ystd = [ystd(1) ystd(i+1:4:n-1) ystd(n)];
    
    %h=errorbar(xvals, y, ystd, 'k');

    if showbar==1
        errorbarloglog(xvals, y, y-ystd,y+ystd,'-','none','k');
        hold on
    else
        %set(h,'linewidth',2);
        h=loglog(xvals,y, c,'MarkerSize',10);
        %errorbarloglog(xvals, y, y-ystd,y+ystd,'-','^','k');

        set(h,'linewidth',2);
        %errorbar(t,mean(x2),std(x2),c);
        %coefs = polyfit(log(x(:,1)), log(x(:,2)), 1)
        % have to reshape data to make it as two really long vectors
        %length(t)*length(x2)

        %tstretch = repmat(t',length(x2),1);
        tstretch = repmat(t',runs,1);
        xstretch = reshape(x2', [], 1);
        coefs = polyfit(log(tstretch), log(xstretch), 1)
        hold on
        if i < 3
            %plot(t, exp(coefs(2))*(t).^(coefs(1)),'k')
        end
        if i==4
            h=legend('SSA','ER-leap','R-leap','\tau-leap', 'Location','NorthWest');
            set(h,'fontsize',11);
        end
    end
    set(gca,'XTick',xticks);
    set(gca, 'YTick',yticks);
end
end
box off
xrange = log10(max(t)) - log10(min(t));
yrange = log10(maxy) - log10(miny);
xlim([min(t) max(t)])
%ylim([miny, maxy]);
yLim = ylim;
yrange = log10(yLim(2)) - log10(yLim(1));
old_ar = get(gca, 'DataAspectRatio')


%set(gca, 'DataAspectRatio', [old_ar(1) old_ar(2)*xrange/yrange old_ar(3)])
%set(gca, 'DataAspectRatio', [old_ar(1) old_ar(2)*yrange/xrange old_ar(3)])
%xlim([min(t) max(t)])
%set(gca, 'DataAspectRatio', new_aspect);
v = xlim;


%h=legend('ssa','erleap','rleap','tauleap', 'Location','NorthWest')
%set(h,'fontsize',16)
%legend('erleap','rleap','tauleap')


%ylim([miny maxy])
xlabel('Initial Molecules','fontsize',12,'fontweight','bold')
ylabel('CPU time / sim time','fontsize',12,'fontweight','bold')
%title('Initial Molecules vs. CPU Time','fontsize',22,'fontweight','bold')
%grid on

% now calculate dx, dy rations so each axis is the same...



%axis equal
hold off

%% 'fun', reads in binary vector outputs index of true
idx = [];
k=1
for i=1:length(z):
    i
    'k'
    if z(i) > 0:
        idx(k)=i
        k = k+1
    end
    
end
idx
%%
kmax = 13;
%min_dists = zeros(1,12);

for k=2:kmax
    min_dist_sum = 999999999999
    for iter = 1:30
        [idx,c, sumd, D]=kmeans(z, k);
        %plot(c(:,1),c(:,2),'+');
        xlim([0,100]);
        ylim([0,100]);
        %dist_sum = sum(sqrt(sumd));
        dist_sum =sum(sqrt(min(D')));
        if dist_sum < min_dist_sum
            min_dist_sum = dist_sum;
        end
    end
    min_dists(k) = min_dist_sum
end


%% force values in vector y to be between -1 and 1
miny = min(y);
maxy = max(y);
diffy = maxy - miny;

y= ((y - miny) / (diffy)) *2 - 1;
    

%% set up colorOrder

x=[
    0.03       0.02474    .06
    0.0000    0.1840    0.2982
    0.1818    0.1794    0.6776
    0.1118    0.6190    0.6176
    0.4039    0.8575    0.0207
    0.6324    0.9038    0.8599
    0.9944    0.8583    0.5511
    ];

for i=1:7
    invi = i/7;
   x(i,:) = [invi*(7-i)/7 invi*(mod(i,3))/2 invi];
   % dark blu/purple [.2 .8 0] -> green[0 1 0] -> yellow [0 1 1]
   x(i,:) = [((7-i)/7)^3    .5/(1+exp(-.5*(i-1)))    .4^(1/i)  ];
   x(i,:) = [.6*abs(sin(pi*i/7))    .6*abs(sin(i/4))    .9*abs(cos(i/4))];
end
set(gca,'ColorOrder',x)
plot(c_out_X,c_out_Y,'.')