# David Orendorff
# 9/4/07.
#
# Run batch tests of rleap, etc

from os import system

inp_data="""<?xml version="1.0" encoding="UTF-8"?>
<sbml xmlns="http://www.sbml.org/sbml/level2" level="2" version="1">
  <model id="BirthDeath01" name="Birth-death model (001), variant 01">
    <listOfUnitDefinitions>
      <unitDefinition id="substance">
        <listOfUnits>
          <unit kind="item" multiplier="1" offset="0"/>
        </listOfUnits>
      </unitDefinition>
    </listOfUnitDefinitions>
    <listOfCompartments>
      <compartment id="Cell"/>
    </listOfCompartments>
    <listOfSpecies>
      <species id="X" compartment="Cell" initialAmount="%d" hasOnlySubstanceUnits="true"/>
    </listOfSpecies>
    <listOfParameters>
      <parameter id="Lambda" value="0.1"/>
      <parameter id="Mu" value="0.11"/>
    </listOfParameters>
    <listOfReactions>
      <reaction id="Birth" reversible="false">
        <listOfReactants>
          <speciesReference species="X"/>
        </listOfReactants>
        <listOfProducts>
          <speciesReference species="X" stoichiometry="2"/>
        </listOfProducts>
        <kineticLaw>
          <math xmlns="http://www.w3.org/1998/Math/MathML">
            <apply>
              <times/>
              <ci> Lambda </ci>
              <ci> X </ci>
            </apply>
          </math>
        </kineticLaw>
      </reaction>
      <reaction id="Death" reversible="false">
        <listOfReactants>
          <speciesReference species="X"/>
        </listOfReactants>
        <kineticLaw>
          <math xmlns="http://www.w3.org/1998/Math/MathML">
            <apply>
              <times/>
              <ci> Mu </ci>
              <ci> X </ci>
            </apply>
          </math>
        </kineticLaw>
      </reaction>
    </listOfReactions>
  </model>
</sbml>"""


runs=[(10, 2), (15, 2.000000), (22, 2.000000), (33, 2.000000), (49, 2.000000), (73, 2.000000), (109, 2.000000), (163, 2.000000), (244, 2.000000), (366, 3.200000), (549, 5.400000), (823, 5.800000), (1234, 7.600000), (1851, 9.400000), (2776, 10.600000), (4164, 10.800000), (6246, 11.400000), (9369, 12.800000), (14053, 17.800000), (21079, 21.200000), (31618, 25.000000), (47427, 27.000000), (71140, 33.400000), (106710, 37.400000), (160065, 44.000000), (240097, 46.000000), (360145, 51.200000), (540217, 67.200000), (810325, 76.200000), (1215487, 82.200000), (1823230, 94.600000), (2734845, 117.600000), (4102267, 126.600000), (6153400, 139.400000), (9230100, 154.600000)]

ssa_run = """method=ssa"""

#methods = ['erleap', 'ssa']
methods = ['ssa']

#methods = tau_variants + rleap_variants + ['ssa']

for method in methods:
    print "\nmethod %s" % method
    fmethod = open(method+'.txt', 'w')
    for i in range(1,2):
	for (mlcs, leap) in runs:
	    f = open('temp.xml', 'w')
	    f.write(inp_data % mlcs)
	    f.close()
	    if method=='erleap':
		cmd = '../Release/er_leap temp.xml 10 30 5 temp -1 %d > temp.out'%int(leap)
	    else:
		cmd = '../Release/er_leap temp.xml 10 30 5 temp 1 > temp.out'
	    print cmd
	    system(cmd)
	    f = open('temp.out', 'r')
	    timelines = filter(lambda s: 'all sim:' in s, f.readlines())
	    f.close()
	    assert(len(timelines)==1)
	    fmethod.write('%d %s\n' % (mlcs, timelines[0].split()[-1]))
	    #mlcs = mlcs * 1.5
    fmethod.close()
