/*
 *  common_unittests.h
 *  gpu_hierleap
 *
 *  Created by David Orendorff on 4/19/12.
 *  Copyright 2012 UC Irvine. All rights reserved.
 *
 */

#ifndef COMMON_UNITTESTS
#define COMMON_UNITTESTS

#include <boost/assign/std/vector.hpp>
#include <math.h>
#include "common.h"

using namespace boost::assign;
using namespace std;

/* 
 * Test functions found in common.h
 */
class CommonTests {
public:
	void test() {
		test_ipow();
		test_normalize();
	}
private:
	void test_ipow() {
		double eps = 0.000000000001;
		assertNearlyEqual(ipow(3.1, 0), pow(3.1, 0), eps);
		assertNearlyEqual(ipow(.1, 1), pow(.1, 1), eps);
		assertNearlyEqual(ipow(1.123, 2), pow(1.123, 2), eps);
		assertNearlyEqual(ipow(1.123, 7), pow(1.123, 7), eps);
		assertNearlyEqual(ipow(1.0123, 49), pow(1.0123, 49), eps);
	}
	
	void test_normalize() {
		vector<double> arr;
		arr += 0,1,2,3,4,5;
		double s = sum(arr);
		normalize(arr, 1.0);
		for (int i = 0; i < arr.size(); i++) {
			assertNearlyEqual(arr[i], i/s);
		}
	}
};

#endif