/*
 *  gpu_randgen.h
 *  gpu_hierleap
 *
 *  Created by David Orendorff on 2/2/11.
 *  Copyright 2011 UC Irvine. All rights reserved.
 *
 */

#ifndef GPU_RANDGEN_H_
#define GPU_RANDGEN_H_

#include <OpenCL/OpenCL.h>

/* Generates random numbers onto GPU memory.
 */
class GpuRandgen {
public:
	virtual void generate_rands_in_gpu(cl_mem randomNumsStorage, int numToGen) = 0;
	
	// This function is used for testing the random number generator.
	virtual void get_many_randints(unsigned int *dst, int nRandsToGen) = 0;
};




#endif 
