/*
 *  opencl_utils.cpp
 *  gpu_hierleap
 *
 *  Created by David Orendorff on 12/14/10.
 *  Copyright 2010 UC Irvine. All rights reserved.
 *
 */

#include "opencl_utils.h"

#include <OpenCL/OpenCL.h>
#include <assert.h>

long kernelRunTime(cl_event event){
	unsigned long endTime = 0, startTime = 0;
	cl_int err = clGetEventProfilingInfo(event, CL_PROFILING_COMMAND_START, sizeof(endTime), &startTime, NULL);
	assert(err == CL_SUCCESS);
	err |= clGetEventProfilingInfo(event, CL_PROFILING_COMMAND_END, sizeof(endTime), &endTime, NULL);
	assert(err == CL_SUCCESS);
	return  endTime - startTime;
}