#ifndef SBML_DATASTRUCTS_H_
#define SBML_DATASTRUCTS_H_

#include <assert.h>
#include <vector.h>
#include <string>

using namespace std;

class SBMLReaction
{
public:
	SBMLReaction(){ assert(false);}
	
	SBMLReaction(double rxnRate) : rate(rxnRate) {}
	
	void addReactant( int speciesIdx, int stoich){
		inpSpecies.push_back(speciesIdx);
		inpStoich.push_back(stoich);
	}
	void addProduct(int speciesIdx, int stoich){
		outSpecies.push_back(speciesIdx);
		outStoich.push_back(stoich);
	}
	
	
	vector<int> inpSpecies;
	vector<int> outSpecies;
	vector<int> inpStoich;
	vector<int> outStoich;
	
	double rate;
};

class SBMLSpecies
{
public:
	SBMLSpecies(){assert(false);}
	SBMLSpecies(char *sName, int x) :x0(x){
		name = string(sName);
	}
	
	int x0;
	string name;
};


#endif /*SBML_DATASTRUCTS_H_*/
